<template>
  <div v-if="requests.length > 0">
    <h4 class="mv-1 mt-2 text-left ph-3">Match requests</h4>
    <div class="d-flex flex-row flex-nowrap matches">
      <div v-for="req of requests" :key="req._id"
        @click="onAcceptReq(req)">
        <img :src="req.from.media[0]">
      </div>
    </div>
  </div>
</template>

<script>
import axios from 'axios';

export default {
  data: () => ({
    requests: [],
  }),
  methods: {
    onAcceptReq(req) {
      this.$bus.$emit('accept-request', req);
      this.$bus.$emit('open-swipe');
    },
  },
  mounted() {
    axios.get('/api/user/requests')
      .then(({data}) => {
        this.requests = data;
      })
      .catch((err) => {
        err;
      });

    this.$bus.$on('new-request', (req) => this.requests.push(req));

    this.$bus.$on('new-match', (match) => {
      let u = match.users[typeof match.users[0] === 'string' ? 1 : 0];
      this.$store.dispatch('getMatches');
      this.requests = this.requests.filter(req => req.from._id !== u._id);
    });

    this.$bus.$on('accepted-match', (user) => {
      this.$store.dispatch('getMatches');
      this.requests = this.requests.filter(req => req.from._id !== user._id);
    });

    this.$bus.$on('rejected-match', (user) => {
      this.requests = this.requests.filter(req => req.from._id !== user._id);
    });
  },
};
</script>

<style scoped>
.matches {
  overflow-x: auto;
  width: 100%;
}

.matches > div {
  margin: 6px .1em;
}

.matches > div:first-child { padding-left: 1em; }
.matches > div:last-child { padding-right: 1em; }

.matches > div img {
  width: 60px;
  height: 60px;
  border-radius: 50%;
  object-fit: cover;
  border: 2px solid white;
}
</style>
